
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_CLIENT_CLT_DATA_FILTER_REGISTRY_H
#define PG_CLIENT_CLT_DATA_FILTER_REGISTRY_H

#include "runtime/ModuleRegistry.h"
#include "runtime/DataFilter.h"

class CltXact;

// registration handler for client-side data filters
class CltDataFilterRegistry: public ModuleRegistry< DataFilter<CltXact*> > {
	public:
		typedef CltXact* Producer;
		typedef DataFilter<Producer> Filter;

	public:
		CltDataFilterRegistry();
		void apply(CltXact *p, IOBuf &buf); // applies to all
};

extern CltDataFilterRegistry &TheCltDataFilterRegistry();

LIB_INITIALIZER(CltDataFilterRegistryInit)

#endif
