
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "client/MembershipMap.h"
#include "client/MembershipGroupIterator.h"


MembershipGroupIterator::MembershipGroupIterator(const MembershipMap *aMembership, Interval &aRange):
	theMembership(aMembership), theRange(aRange), thePos(aRange.beg()) {
	sync();
}

String MembershipGroupIterator::operator *() const {
	if (Should(!atEnd()))
		return theMembership->groupNameAt(thePos);
	else
		return String();
}

MembershipGroupIterator &MembershipGroupIterator::operator ++() {
	if (!atEnd()) {
		step();
		sync();
	}
	return *this;
}
