
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_PRIVATE_WORLD_CLASS_H
#define PG_PRIVATE_WORLD_CLASS_H

#include "runtime/ObjWorld.h"

class PrivWorld: public ObjWorld {
	public:
		// based on all local private worlds
		static int TheFrozenCount;
		static int TheTotalCount;
		static int TheWss;

		static bool Frozen();

	public:
		PrivWorld() {}
		PrivWorld(const UniqId &anId);

		void produce(ObjId &oid, RndGen &rng);
		void freezeWss();
};

inline
OBStream &operator <<(OBStream &os, const PrivWorld &pw) {
	pw.store(os);
	return os;
}

inline
IBStream &operator >>(IBStream &is, PrivWorld &pw) {
	pw.load(is);
	return is;
}

#endif
