
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_BODY_ITERATOR_H
#define PG_BODY_ITERATOR_H

#include "xstd/Rnd.h"
#include "base/ObjId.h"

class WrBuf;
class ContentCfg;

class BodyIter {
	public:
		BodyIter();
		virtual ~BodyIter();

		virtual void reset();

		void contentCfg(const ContentCfg *cfg) { theContentCfg = cfg; }
		void oidCfg(const ObjId &anOid, int aHash) { theOid = anOid; theContentHash = aHash; }
		virtual void configure(WrBuf *aBuf, Size aContSize);
		virtual void stop() {}

		const ObjId &oid() const { return theOid; }
		int contentHash() const { return theContentHash; }
		Size builtSize() const { return theBuiltSize; }
		Size offSeed() const { return theContentHash; }

		void pour();  // fills the buffer

		operator void *() const { return theBuiltSize < theContSize ? (void*)-1 : 0; }

	protected:
		void pourPrefix();
		virtual void pourBody() = 0;
		Size sizeLeft() const { return theContSize - theBuiltSize; }

	protected:
		const ContentCfg *theContentCfg;
		ObjId theOid;  // XXX: replace with a pointer when ObjRec is removed
		WrBuf *theBuf;
		RndGen theRng;
		Size theContSize;
		int theContentHash;

		Size theBuiltSize;
};

#endif
