
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_LOAD_TRACE_FIGURE_H
#define PG_LOAD_TRACE_FIGURE_H

#include "xstd/String.h"
#include "loganalyzers/ReportTraceFigure.h"

class LoadStex;
class PhaseInfo;
class PhaseTrace;
class StatIntvlRec;

// creates load trace figure based on interval load stats
class LoadTraceFig: public ReportTraceFigure {
	public:
		typedef LoadStex Stex;

	public:
		LoadTraceFig();

		void stats(const Stex *aStex1, const Stex *aStex2, const PhaseInfo *phase);

	protected:
		virtual int createCtrlFile();
		virtual void setCtrlOptions();

		int dumpDataLines(const LoadStex *stex);
		int dumpDataLine(const LoadStex *stex, Time stamp, const StatIntvlRec &r);
		
	protected:
		const Stex *theStex1;
		const Stex *theStex2;
		const PhaseInfo *thePhase;
		const PhaseTrace *theTrace;
};

#endif
