
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_REPORTERS_OPTS
#define PG_REPORTERS_OPTS

#include "base/opts.h"
#include "base/polyOpts.h"

// options for the reporter
class RepOpts: public OptGrp {
	public:
		RepOpts(); // defaults

		virtual ostream &printAnonym(ostream &os) const;
		virtual bool parseAnonym(const Array<const char *> &opts);
		virtual bool canParseAnonym() const { return true; }

		virtual bool validate() const;
		
	public:
		HelpOpt theHelpOpt;
		VersionOpt theVersOpt;
		StrOpt theLabel;
		StrArrOpt thePhases;
		StrOpt theRepDir;
		StrOpt theTmpDir;
		StrOpt thePlotter;
		Array<String*> theFiles;
};

extern RepOpts TheRepOpts;

#endif
