
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_REPORT_FIGURE_H
#define PG_REPORT_FIGURE_H

#include "xstd/String.h"

class String;
class PhaseInfo;
class BlobDb;
class ReportBlob;

// creates response time distribution figure based on phase stats
class ReportFigure {
	public:
		static String TheBaseDir; // where to put all figures

	public:
		ReportFigure();
		virtual ~ReportFigure();

		const String &title() const { return theTitle; }

		virtual void configure(const String &key, const String &title);

		virtual const ReportBlob &plot(BlobDb &db);

	protected:
		virtual int createCtrlFile() = 0;
		virtual void setCtrlOptions() = 0;
		bool plotCtrlFile();
		bool destroyCtrlFile();
		
	protected:
		const PhaseInfo *thePhase;
		String theKey;
		String theTitle;
		String theBaseName;
		String thePlotFname;
		String theCtrlFname;

		ostream *theCtrlFile;
};

#endif
