
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_TIME_AND_SIZE_HISTOGRAM_FIGURE_H
#define PG_TIME_AND_SIZE_HISTOGRAM_FIGURE_H

#include "loganalyzers/ReportFigure.h"

class Stex;
class TmSzHistStat;
class Histogram;
class HistogramBin;
class PhaseInfo;

// creates response time distribution figure based on phase stats
class TmSzHistFig: public ReportFigure {
	public:
		TmSzHistFig();

		void stats(const Stex *aStex, const PhaseInfo *phase);

	protected:
		virtual int createCtrlFile();
		virtual void setCtrlOptions();
		virtual const Histogram &extractHist(const TmSzHistStat &stats) const = 0;
		int dumpDataLine(const HistogramBin &bin, int totCount);
		
	protected:
		const Stex *theStex;
		const PhaseInfo *thePhase;
};

#endif
