
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_CREDENTIALS_ARRAY_SYMBOL_H
#define PGL_CREDENTIALS_ARRAY_SYMBOL_H

#include "pgl/PglContainerSym.h"
#include "pgl/CredentialsGen.h"

class StringSym;

// a compact representation of an array of user credentials
class CredArrSym: public ContainerSym {
	public:
		static String TheType;

	public:
		CredArrSym();
		virtual ~CredArrSym();

		virtual bool isA(const String &type) const;

		virtual int count() const;
		virtual bool probsSet() const;
		virtual const SynSym *itemProb(int offset, double &prob) const;

		void configure(int aCount, const String &aNamespace);

		virtual void toStringArray(StringArray &strs) const;

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		virtual SynSym *dupe(const String &type) const;

	protected:
		CredentialsGen theGen;

		mutable StringSym *theCreds; // cache for itemProb()
};

#endif
