
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_PGL_NET_ADDR_PARTS_H
#define PG_PGL_NET_ADDR_PARTS_H

#include "xstd/String.h"

class PglNetAddrParts {
	public:
		enum HostKind { hkNone, hkDomainName, hkIPv4, hkIPv6 };

	public:
		PglNetAddrParts(const String &anImage);

		const String &error() const { return theError; }
		bool single() const;

		HostKind hostKind() const { return theHostKind; }
		const String &ifName() const { return theIfname; }
		const String &hosts() const { return theHosts; }
		const String &ports() const { return thePorts; }
		int subnet() const { return theSubnet; }

		// check that single() is true before calling these
		const String &host() const;
		int port() const;

	protected:
		bool parse();
		bool parseIfname();
		bool determineHostKind();
		bool parseSubnet();
		bool parseHosts();
		bool parsePorts();

	protected:
		String theImage;

		HostKind theHostKind;

		String theIfname;
		String theHosts;
		String thePorts;
		int theSubnet;

		String theError;
		String theBuf; // unparsed content
};

#endif
