
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_SIZE_SYMBOL_H
#define PGL_SIZE_SYMBOL_H

#include "xstd/BigSize.h"
#include "pgl/PglExprSym.h"

class TimeSym;
class BwidthSym;
class RateSym;
class NumSym;

// size

class SizeSym: public ExpressionSym {
	public:
		static String TheType;

	public:
		SizeSym(const BigSize &aVal);

		BigSize val() const { return theVal; }
		void val(BigSize v) { theVal = v; }

		virtual bool isA(const String &type) const;

		virtual ExpressionSym *unOper(const Oper &op) const;
		virtual ExpressionSym *bnOper(const Oper &op, const SynSym &exp) const;

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;

		ExpressionSym *operSS(const Oper &op, SizeSym *ss, const SynSym &exp) const;
		ExpressionSym *operST(const Oper &op, TimeSym *ts, const SynSym &s) const;
		ExpressionSym *operSR(const Oper &op, RateSym *rs, const SynSym &s) const;
		ExpressionSym *operSB(const Oper &op, BwidthSym *bs, const SynSym &s) const;
		ExpressionSym *operSN(const Oper &op, NumSym *ns, const SynSym &exp) const;

	protected:
		BigSize theVal;
};

#endif
