
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_SERVER_SYMBOL_H
#define PG_SERVER_SYMBOL_H

#include "pgl/AgentSym.h"

class StringSym;
class ContentSym;
class RndDistr;

// server side configuration
class ServerSym: public AgentSym {
	public:
		static const String TheType;

	public:
		ServerSym();
		ServerSym(const String aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		bool acceptLmt(int &lmt) const;
		bool contents(Array<ContentSym*> &ccfgs, Array<double> &cprobs) const;
		bool directAccess(Array<ContentSym*> &dacfgs, Array<double> &daprobs) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
		virtual String msgTypesField() const;
};

#endif
