
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_RUNTIME_DUT_STATE_H
#define PG_RUNTIME_DUT_STATE_H

#include "xstd/Time.h"
#include "xstd/BigSize.h"
#include "runtime/MeasRange.h"

class DutStateSym;
class StatIntvlRec;

// describes desired DUT state
class DutState {
	public:
		DutState();

		void configure(const DutStateSym &cfg);

		bool reached(const StatIntvlRec &stats) const;

		ostream &print(ostream &os, const String &pfx) const;

	public:
		MeasRange<Time> rptm;
		MeasRange<BigSize> fillSize;
		MeasRange<int> xactions;
		MeasRange<double> repRate;
		MeasRange<int> errors;
		MeasRange<double> errorRatio;
		MeasRange<double> dhr;
};

#endif
