
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_XML_RENDERER_H
#define PG_XML_RENDERER_H

class XmlDoc;
class XmlNode;
class XmlTag;
class XmlNodes;

// rendering interface
class XmlRenderer {
	public:
		virtual ~XmlRenderer() {}

		virtual void render(const XmlDoc &doc) = 0;

		void renderNode(const XmlNode &node);
		virtual void renderText(const char *buf, Size sz) = 0;
		virtual void renderTag(const XmlTag &tag) = 0;

	protected:
		void foreach(const XmlNodes *nodes);
};

#endif
