
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xml/XmlText.h"
#include "xml/XmlAttr.h"
#include "xml/XmlSection.h"

XmlSection::XmlSection(): XmlTag("section") {
}

XmlSection::XmlSection(int level): XmlTag("section") {
	addAttr(new XmlAttr(XmlAttr::Int("level", level)));
}

XmlSection::XmlSection(int level, const String &title): XmlTag("section") {
	addAttr(new XmlAttr(XmlAttr::Int("level", level)));
	XmlTag t("title");
	t << XmlText(title);
	addChild(t.clone());
}

XmlSection::XmlSection(const String &title): XmlTag("section") {
	XmlTag t("title");
	t << XmlText(title);
	addChild(t.clone());
}
