
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef XPARSER_TOKEN_SYMBOL_H
#define XPARSER_TOKEN_SYMBOL_H

#include "xparser/SynSym.h"

// The TokenSym class maintains "token" attributes that
// store tokens as they come from a Lexer

class TokenSym : public SynSym {
	public:
		static const String TheType;

	public:
		TokenSym(const String &n, int anId = -1);

		int id() const { return theId; }
		const String &spelling() const { return theSpell; }

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		virtual SynSym *dupe(const String &) const;

	private:
		String theSpell;
		int theId;
};

#endif
