
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef XSTD_LOADABLE_MODULE_H
#define XSTD_LOADABLE_MODULE_H

#include "xstd/String.h"

// wrapper for dlopen(3) and friends
class LoadableModule {
	public:
		enum LoadMode { lmNow, lmLazy };

	public:
		LoadableModule(const String &aName);
		~LoadableModule();                   // unloads if loaded

		bool loaded() const;
		const String &name() const { return theName; }
		const String &error() const { return theError; }

		bool load(int mode = lmNow);
		bool unload();

	protected:
		String theName;
		String theError;
		void *theHandle;
};

#endif
